package com.jwl.driver.server;

import com.jwl.driver.server.config.WechatPayConfig;
import com.jwl.driver.server.service.IOrderPayInfoService;
import com.jwl.driver.server.service.ITdSysUserMemberService;
import com.jwl.driver.server.util.InputStreamUtil;
import com.wechat.pay.java.core.Config;
import com.wechat.pay.java.core.RSAAutoCertificateConfig;
import com.wechat.pay.java.core.util.IOUtil;
import com.wechat.pay.java.core.util.PemUtil;
import com.wechat.pay.java.service.payments.h5.H5Service;
import com.wechat.pay.java.service.payments.jsapi.JsapiServiceExtension;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.Profile;
import org.springframework.core.io.ClassPathResource;
import org.springframework.data.repository.init.ResourceReader;

import java.io.IOException;
import java.io.InputStream;
import java.io.UncheckedIOException;

/**
 * @author 曹林
 * @description 微信支付
 * @create 2023/8/21 10:36
 */
@SpringBootTest
@Profile("dev")
public class WechatPayTest {

    @Autowired
    private WechatPayConfig wechatPayConfig;

    @Autowired
    private ITdSysUserMemberService userMemberService;

    @Autowired
    private IOrderPayInfoService payInfoService;

    @Test
    void createService() throws IOException {
        Config config =
                new RSAAutoCertificateConfig.Builder()
                        .merchantId(wechatPayConfig.getMchId())
                        .privateKey(PemUtil.loadPrivateKeyFromString(InputStreamUtil.getContentStr("wechatPay/apiclient_key.pem")))
//                        .privateKeyFromPath(wechatPayConfig.getPrivateKeyPath())
                        .merchantSerialNumber(wechatPayConfig.getMchSerialNo())
                        .apiV3Key(wechatPayConfig.getApiV3Key())
                        .build();
        H5Service service = new H5Service.Builder().config(config).build();
    }

    @Test
    void purchaseMember(){
        String trade_state = "SUCCESS";
        String outTradeNo = "1694594904308846592";
        if(trade_state.equals("SUCCESS")) {
            //各种业务逻辑
            //1.订单详情表里修改数据
            payInfoService.payNotice(Long.parseLong(outTradeNo),Boolean.FALSE);
            //2.冲会员
            userMemberService.purchaseMember(Long.parseLong(outTradeNo));

        }else{
            //还是各种业务逻辑
            //1.订单详情表里修改数据
            payInfoService.payNotice(Long.parseLong(outTradeNo),Boolean.FALSE);
        }
    }
}
